; fvputs.inc
; Copyright 1999 Joshua Seagoe rabidcow@juno.com
; include fvputequ.inc at top
; look there for more comments

fvputs128:						;1024-byte gfx buffer
		xor a
		ld (fvputs_width),a
		push hl
		ld hl,15
		ld (fvputc_scr2),hl
		ld de,(_pencol)
		inc d
		ld l,d
		ld h,0
		add hl,hl
		add hl,hl
		add hl,hl
		add hl,hl
		jr fvputs_continue
fvputs:							;768-byte gfx buffer
;Heavily modified from original routine!!!
		xor a
		ld (fvputs_width),a
		push hl
		ld hl,11
		ld (fvputc_scr2),hl
		ld de,(_pencol)
		ld l,d
		ld h,0
		add hl,hl
		add hl,hl
		ld b,h
		ld c,l
		add hl,hl
		add hl,bc
fvputs_continue:
		ld a,e
		rra
		rra
		rra
		and %00011111
		add a,l
		ld l,a
		ld a,h
fvputc_vidplane	equ	$+1
		adc a,0
		ld h,a
        ld a,e                  ; a = x%8 (bit offset in byte
        and 7
		ld (fvputs_addr),hl
		ld (fvputs_mask),a
		pop hl
fvputs_loop:
        ld a,(hl)
        or a                    ; return on zero
        jr z,fvputs_end
        push hl
        call fvputc             ; display one char
        pop hl
        inc hl                  ; next char
        jr fvputs_loop
fvputs_end:
fvputs_width	equ	$+1
		ld b,0					;return width of text in a
		ret


fvputc:
		call _copycharmaps
        ld a,(hl)
        cp 9                    ; must be less than 9 wide
        ret nc
        or a
        ret z                   ; don't bother if it's 0 wide
        push hl                 ; save bitmap
		ld b,a
		ld a,(fvputs_width)
		add a,b
		ld (fvputs_width),a
		ld hl,(fvputs_addr)
		ld a,(fvputs_mask)
		add a,b
		ld b,a
		rra
		rra
		rra
		and %00011111
		add a,l
		ld l,a
		ld a,h
		adc a,0
		ld h,a
		ld a,b
		and %00000111
		ld (fvputs_mask),a
		ld (fvputs_addr),hl
		dec hl
        pop de                  ; de -> bitmap width byte
		ld c,a
        inc de                  ; de -> bitmap (6 bytes)
        inc de                  ; skip blank row
		ld b,5
fvputc_putiloop:                ; or image to screen
		ld a,h						;(make sure the text isn't off the screen)
fvputc_vidplane2	equ	$+1
		cp 0
		ret nc
        ld a,(de)               ; load row
        push bc
        ld b,c
        push de
        ld e,a
        ld d,0
        ld a,b
        or a
        jr z,fvputc_noshifti
fvputc_shiftiloop:              ; shift row of image
        or a                    ; clear carry
        rr e
        rr d
        djnz fvputc_shiftiloop
fvputc_noshifti:
		ld a,e
		call pixel_op
        inc hl
		ld a,d
		call pixel_op
fvputc_scr2	equ	$+1
        ld de,15
        add hl,de               ; go to next row
        pop de
        inc de
        pop bc
		djnz fvputc_putiloop    ; do rest of bitmap
        ret

fvputs_addr: .dw 0
fvputs_mask: .db 0

.end