;MLC (Multi-platform Language for Calculators) by Epic Programming Studios
;TI-86 interpreter
;Written by Donald Straney (burntfuse) - straney@umbi.umd.edu

;Pre-tokenized program create/execute code


;structure of pre-tokenized program in file
;
;$01				1
;"MLC:"				4
;$D6				1
;[free1_mem_ptr]	2
;[free2_mem_ptr]	2
;[free3_mem_ptr]	2
;[free4_mem_ptr]	2
;[num_sprs]			1
;[start_addr]		2
;[bmp data len]		2
;(bmp data)
;(program)
;$FF				1


tok_prog:
	push hl
	rst 20h
	call _pushrealo1
	pop hl
	call tok_part_1
	call tok_part_2
	ld hl,tok_header_str
	ld de,$ca00
	ld bc,6
	ldir
	ld hl,free1_mem_ptr
	ld bc,8
	ldir
	ld a,(num_sprites)
	ld (de),a
	inc de
	ld hl,start_addr
	ld bc,2
	ldir
	ld hl,(bmp_mem_ptr)
	ld bc,bmp_mem
	or a
	sbc hl,bc
	ex de,hl
	ld (hl),e
	inc hl
	ld (hl),d
	inc hl
	ex de,hl
	ld a,h
	or l
	jr z,tok_prog_skip_bmp
	ld b,h
	ld c,l
	ld hl,bmp_mem
	ldir
tok_prog_skip_bmp:
	ld hl,$ca00
	ex de,hl
	or a
	sbc hl,de
	push hl
	push hl
	call _poprealo1
	call _pushrealo1
	rst 10h
	call _delvar
	call _poprealo1
	ld hl,(write_ptr)
	inc hl
	ld de,write_addr
	or a
	sbc hl,de
	pop de
	add hl,de
	call _createprog
	ld a,b
	ex de,hl
	call _ahl_plus_2
	call _set_abs_dest_addr
	ld hl,$ca00
	xor a
	call _set_abs_src_addr
	pop hl
	call _mm_ldir_set_size
	ld a,1
	ld hl,write_addr-$8000
	call _set_abs_src_addr
	ld hl,(write_ptr)
	inc hl
	ld de,write_addr
	xor a
	sbc hl,de
	call _mm_ldir_set_size
	jp prog_loop


exec_tok_prog:
	ld hl,copy_addr+6
	ld de,free1_mem_ptr
	ld bc,8
	ldir
	ld a,(hl)
	ld (num_sprites),a
	inc hl
	ld de,start_addr
	ld bc,2
	ldir
	ld c,(hl)
	inc hl
	ld b,(hl)
	inc hl
	ld a,b
	or c
	jr z,exec_tok_prog_skip_bmp
	ld de,bmp_mem
	ldir
exec_tok_prog_skip_bmp:
	ld de,write_addr
	ld bc,end_copy_addr-copy_addr
	ldir
	jp exec_prog


tok_header_str: .db $01
header_str: .db "MLC:",$d6,0

.end