;MLC (Multi-platform Language for Calculators) by Epic Programming Studios
;TI-86 interpreter
;Written by Donald Straney (burntfuse) - straney@umbi.umd.edu

;Variable storage/management code (execute)


set_var_warray:				;set var with address in de to data in hl, look for array index in (expr_sum) and var type in (curr_var_type)
	ld a,(curr_var_type)	;first, what type of var is it?
	cp int_name_token
	jr z,set_var			;if it's an int, we can get off easy ;-)
	push hl
	call get_var
	ld b,(hl)				;otherwise, it's an array element that has to be set
	inc hl					;so first make sure that the index isn't out of bounds
	ld de,(expr_sum)
	ld a,d
	or a
	jp nz,err_arrayindex
	ld a,e
	cp b
	jp nc,err_arrayindex
	add a,a					;then find the address of the array element
	ld c,a
	ld b,0
	add hl,bc
	pop de					;and set it
	ld (hl),e
	inc hl
	ld (hl),d
	ret


set_var:					;set variable with address of de to data in hl
	ex de,hl
	ld (hl),e
	inc hl
	ld (hl),d
	ret


get_var:					;get variable with address in de, return data in hl
	ex de,hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	ex de,hl
	ret

.end