;version 1.0
;2/11/2005 build 3

;MLC (Multi-platform Language for Calculators) by Epic Programming Studios
;TI-86 sprite editor
;Written by Donald Straney (burntfuse) - straney@umbi.umd.edu

;Main code

#include "86.h"

;PROGRAM SETTINGS

title_bar_height	equ	7				;height of title bar
spr_grid_pos	equ		$080f			;position for sprite grid
cur_init_x		equ		8				;initial position for cursor
cur_init_y		equ		8+title_bar_height
spr_size_pos	equ		$1a0b			;cursor position for sprite size prompt
key_msg_pos		equ		$083c			;cursor position for key help messages
out_code_pos	equ		$0800			;cursor position for sprite code output
screen_len		equ		1024			;length of screen in bytes
tile_spacing	equ		3				;number of pixels between each tile on screen

;MEMORY ALLOCATION

scrn1_buf		equ		$ca00			;		screen buffers for grayscale
scrn2_buf		equ		$fc00
int_ram			equ		$d2fe			;		IM1 isr for grayscale
int_chksum		equ		$d2fd
vsprite_l1		equ		$8100			;32		virtual sprite
vsprite_l2		equ		vsprite_l1+32	;32
vsprite_mask	equ		vsprite_l2+32	;32
spr_size		equ		vsprite_mask+32	;1		size of current sprite
cur_x			equ		spr_size+1		;1		x position of cursor
cur_y			equ		cur_x+1			;1		y position of cursor
cur_byte		equ		cur_y+1			;2		pointer to current byte in virtual sprite
cur_bit			equ		cur_byte+2		;1		bitmask for current pixel in virtual sprite
spr_right		equ		cur_bit+1		;1		limits of sprite on screen
spr_bot			equ		spr_right+1		;1

.org _asm_exec_ram

	nop
	jp prog_start

	.dw 0,shell_title

shell_title: .db "MLC sprite editor",0

prog_start:
	ld de,0
	ld bc,1023
	call clr_scrn						;ahh...that familiar init code...
	call _flushallmenus
	call _runindicoff
	ld hl,0
	ld (_pencol),hl						;draw the title bar
	ld hl,str_title_bar
	set textInverse,(iy+textflags)
	set textEraseBelow,(iy+textflags)
	call _vputs
	res textInverse,(iy+textflags)
	ld hl,scrn2_buf						;and copy it to the second buffer
	ld de,scrn1_buf
	ld bc,16*title_bar_height
	ldir
	call open_gray						;then open the grayscale handler
	ld hl,spr_size_pos					;and ask the most important question to the user -
	ld (_pencol),hl						;"8x8 or 16x16?"
	ld a,l
	ld (_vnewline_patch),a
	ld hl,str_spr_size
	call _vputs
	call _vnewline
	ld hl,str_spr_size_1
	call _vputs
	call _vnewline
	ld hl,str_spr_size_2
	call _vputs
size_key_loop:
	call _getkey						;wait for the answer...
	cp kExit							;if that stupid loser pressed the exit key, then quit the program
	jp z,prog_end
	cp kF1
	jr z,spr_8
	cp kF2
	jr nz,size_key_loop
spr_16:
	ld a,16								;otherwise, set the sprite size
	jr spr_size_end
spr_8:
	ld a,8
spr_size_end:
	ld (spr_size),a
	ld de,16*title_bar_height			;when a sprite size has been selected,
	ld bc,1023-(16*title_bar_height)
	call clr_scrn						;clear the screen from the title bar down
	ld d,a
	ld e,a
	ld bc,spr_grid_pos
spr_grid_row_loop:						;then draw a blank grid
	push de
	push bc
	ld hl,spr_white_tile
	call GraySprite						;first draw the tile
	pop bc
	pop de
	ld a,b
	add a,tile_spacing					;then move to the next column
	ld b,a
	dec d								;are we at the end of the row yet?
	jr nz,spr_grid_row_loop				;if not, loop again
	ld b,spr_grid_pos/256				;when at the end of the row, reset the x pos to the beginning of the row,
	ld a,c
	add a,tile_spacing
	ld c,a								;move to the next row,
	ld a,(spr_size)
	ld d,a								;reset the column counter,
	dec e								;and decrement the row counter
	jr nz,spr_grid_row_loop				;if it's not at the end, go back and draw the next row
	ld a,cur_init_x						;when it's done with the grid, init the cursor position
	ld (cur_x),a
	ld a,cur_init_y
	ld (cur_y),a
	ld a,(spr_size)						;and limits of the on-screen sprite
	dec a
	ld b,a
	add a,a								;*2
	add a,b								;*3
	ld b,a
	add a,cur_init_x
	ld (spr_right),a
	ld a,cur_init_y
	add a,b
	ld (spr_bot),a
	ld hl,vsprite_l1					;then clear the virtual sprite
	ld (cur_byte),hl
	ld a,$80
	ld (cur_bit),a
	ld de,vsprite_l1+1
	ld (hl),0
	ld bc,95
	ldir
	ld hl,key_msg_pos					;and draw the key messages
	ld (_pencol),hl
	ld a,l
	ld (_vnewline_patch),a
	ld hl,str_keys
	call _vputs
	call _vnewline
	ld hl,str_keys_1
	call _vputs
	call _vnewline
	ld hl,str_keys_2
	call _vputs
	call _vnewline
	ld hl,str_keys_3
	call _vputs
	call _vnewline
	ld hl,str_keys_4
	call _vputs
	call _vnewline
	ld hl,str_keys_5
	call _vputs
	call _vnewline
	ld hl,str_keys_6
	call _vputs
	call _vnewline
	ld hl,str_keys_7
	call _vputs
main_loop:
	ld a,(cur_x)						;draw the cursors
	ld b,a
	ld c,title_bar_height
	ld hl,spr_d_arrow
	call GraySprite						;first the down arrow (x cursor)
	ld a,(cur_y)
	ld c,a
	ld b,0
	ld hl,spr_r_arrow
	call GraySprite						;then the right arrow (y cursor)
main_key_loop:
	call _getkey						;wait for a keypress
	cp kExit
	jp z,prog_end						;if it's exit, then quit the prog
	cp kEnter
	jp z,show_spr_code					;if it's enter, show the sprite code in hex
	dec a
	jp z,move_right						;if it's one of the arrow keys, move the cursor,
	dec a
	jp z,move_left
	dec a
	jp z,move_up
	dec a
	jp z,move_down
	sub k0-kDown
	ld ix,(cur_byte)					;(past this point, it must be a number key, so
	ld d,a								;set up the parameters for easily changing
	ld a,(cur_x)						;the color of a tile - b,c=x,y pos of tile on screen,
	ld b,a								;ix=address of tile in virtual sprite, a=bitmask for tile
	ld a,(cur_y)
	ld c,a
	ld a,(cur_bit)
	jr z,set_white						;and if it's one of the numbers, set the color
	dec d
	jr z,set_lgray
	dec d
	jr z,set_dgray
	dec d
	jr z,set_black
	dec d
	jr nz,main_key_loop
set_clear:
	call set_l1_off						;set the color in the virtual sprite,
	call set_l2_off
	call set_mask_on
	ld hl,spr_clear_tile				;then select the tile to be drawn on-screen
	jr set_color
set_white:
	call set_l1_off
	call set_l2_off
	call set_mask_off
	ld hl,spr_white_tile
	jr set_color
set_lgray:
	call set_l1_on
	call set_l2_off
	call set_mask_off
	ld hl,spr_lgray_tile
	jr set_color
set_dgray:
	call set_l1_off
	call set_l2_on
	call set_mask_off
	ld hl,spr_dgray_tile
	jr set_color
set_black:
	call set_l1_on
	call set_l2_on
	call set_mask_off
	ld hl,spr_black_tile
set_color:
	call GraySprite						;draw the tile on-screen to represent the virtual sprite
	jp main_key_loop

set_l1_off:
	ld d,a
	cpl
	and (ix+0)
	ld (ix+0),a
	ret
set_l2_off:
	ld a,d
	cpl
	and (ix+32)
	ld (ix+32),a
	ret
set_mask_off:
	ld a,d
	cpl
	and (ix+64)
	ld (ix+64),a
	ret
set_l1_on:
	ld d,a
	or (ix+0)
	ld (ix+0),a
	ret
set_l2_on:
	ld a,d
	or (ix+32)
	ld (ix+32),a
	ret
set_mask_on:
	ld a,d
	or (ix+64)
	ld (ix+64),a
	ret

move_right:
	ld hl,cur_x
	ld a,(spr_right)
	cp (hl)								;make sure that the cursor's not at the edge of the board
	jp z,main_key_loop
	ld a,(hl)							;then move the cursor position
	ld b,a
	add a,tile_spacing
	ld (hl),a
	ld c,title_bar_height
	ld hl,spr_no_arrow					;and erase the old cursor
	call GraySprite
	ld hl,(cur_byte)					;also update the virtual sprite pointer
	ld a,(cur_bit)
	rrca
	ld (cur_bit),a
	jr nc,$+3
	inc hl
	ld (cur_byte),hl
	jp main_loop

move_left:
	ld hl,cur_x
	ld a,cur_init_x
	cp (hl)
	jp z,main_key_loop
	ld a,(hl)
	ld b,a
	sub tile_spacing
	ld (hl),a
	ld c,title_bar_height
	ld hl,spr_no_arrow
	call GraySprite
	ld hl,(cur_byte)
	ld a,(cur_bit)
	rlca
	ld (cur_bit),a
	jr nc,$+3
	dec hl
	ld (cur_byte),hl
	jp main_loop

move_up:
	ld hl,cur_y
	ld a,cur_init_y
	cp (hl)
	jp z,main_key_loop
	ld a,(hl)
	ld c,a
	sub tile_spacing
	ld (hl),a
	ld b,0
	ld hl,spr_no_arrow
	call GraySprite
	ld hl,(cur_byte)
	ld a,(spr_size)
	and %11111000
	rra
	rra
	rra
	ld e,a
	ld d,0
	or a
	sbc hl,de
	ld (cur_byte),hl
	jp main_loop

move_down:
	ld hl,cur_y
	ld a,(spr_bot)
	cp (hl)
	jp z,main_key_loop
	ld a,(hl)
	ld c,a
	add a,tile_spacing
	ld (hl),a
	ld b,0
	ld hl,spr_no_arrow
	call GraySprite
	ld hl,(cur_byte)
	ld a,(spr_size)
	and %11111000
	rra
	rra
	rra
	ld e,a
	ld d,0
	add hl,de
	ld (cur_byte),hl
	jp main_loop


show_spr_code:
	ld de,16*title_bar_height			;again, clear the screen from the title bar down,
	ld bc,1023-(16*title_bar_height)
	call clr_scrn
	ld hl,out_code_pos					;position the cursor,
	ld (_pencol),hl
	ld a,l
	ld (_vnewline_patch),a
	ld a,(spr_size)
	cp 8
	jr z,show_spr_code_8
show_spr_code_16:
	ld a,32
show_spr_code_8:
	ld d,a								;d=columns
	ld hl,vsprite_l1
	call show_spr_code_row
	call _vnewline						;when done with that row, go to the next row
	ld hl,vsprite_l2					;and draw the next layer
	call show_spr_code_row
	call _vnewline						;then go to the next line again
	ld hl,vsprite_mask
	call show_spr_code_row				;and draw the final layer
	call _getkey						;now wait for a keypress
	jr prog_end							;and exit

show_spr_code_row:
	push de
	push de
	ld a,Lcolon							;draw a colon at the beginning of the row
	call _vputmap
	pop de
show_spr_code_row_loop:
	ld a,(_pencol)						;(first check if the cursor's at the end of the line)
	cp 120
	jr c,$+7
	push hl
	call _vnewline
	pop hl
	ld a,(hl)							;get the byte
	call conv_hex						;convert it to ASCII digits
	ld a,b
	push de
	call _vputmap						;then draw it
	ld a,c
	call _vputmap
	pop de
	inc hl
	dec d
	jr nz,show_spr_code_row_loop
	pop de
	ret


prog_end:
	call close_gray
	ld de,0
	ld bc,1023
	jp clr_scrn


;Other code sections

#include "data.asm"						;data, you idiot! what else would it be? monkeys?
#include "routines.asm"					;useful routines

.end